DL_GroupPrecomputation< T > Class Template Referenceabstract

DL_GroupPrecomputation interface. More...

## Public Types

typedef T | Element

## Public Member Functions

virtual bool | NeedConversions () const
| Determines if elements needs conversion. More...
virtual Element | ConvertIn (const Element &v) const
| Converts an element between representations. More...
virtual Element | ConvertOut (const Element &v) const
| Converts an element between representations. More...
virtual const AbstractGroup< Element > & | GetGroup () const =0
| Retrieves AbstractGroup interface. More...
virtual Element | BERDecodeElement (BufferedTransformation &bt) const =0
| Decodes element in DER format. More...
virtual void | DEREncodeElement (BufferedTransformation &bt, const Element &P) const =0
| Encodes element in DER format. More...

## Detailed Description

### template<class T>
class DL_GroupPrecomputation< T >

DL_GroupPrecomputation interface.

Template Parameters

  T | Field element

Definition at line 19 of file eprecomp.h.

## Member Function Documentation

## NeedConversions()

template<class T >

virtual bool DL_GroupPrecomputation< T >::NeedConversions | ( |  | ) | const

inline virtual

Determines if elements needs conversion.

Returns
  true if the element needs conversion, false otherwise

NeedConversions determines if an element must convert between representations.

Reimplemented in ModExpPrecomputation, and EcPrecomputation< ECP >.

Definition at line 29 of file eprecomp.h.

## ConvertIn()

template<class T >

virtual Element DL_GroupPrecomputation< T >::ConvertIn | ( | const Element & | v | ) | const

inline virtual

Converts an element between representations.

Parameters

  v | element to convert

Returns
  an element converted to an alternate representation for internal use

ConvertIn is used when an element must convert between representations.

Reimplemented in ModExpPrecomputation, and EcPrecomputation< ECP >.

Definition at line 35 of file eprecomp.h.

## ConvertOut()

template<class T >

virtual Element DL_GroupPrecomputation< T >::ConvertOut | ( | const Element & | v | ) | const

inline virtual

Converts an element between representations.

Parameters

  v | element to convert

Returns
  an element converted from an alternate representation

Reimplemented in ModExpPrecomputation, and EcPrecomputation< ECP >.

Definition at line 40 of file eprecomp.h.

## GetGroup()

template<class T >

virtual const AbstractGroup<Element>& DL_GroupPrecomputation< T >::GetGroup | ( |  | ) | const

pure virtual

Retrieves AbstractGroup interface.

Returns
  GetGroup() returns the AbstractGroup interface

Implemented in ModExpPrecomputation, DL_GroupPrecomputation_LUC, EcPrecomputation< ECP >, and EcPrecomputation< EC2N >.

## BERDecodeElement()

template<class T >

virtual Element DL_GroupPrecomputation< T >::BERDecodeElement | ( | BufferedTransformation & | bt | ) | const

pure virtual

Decodes element in DER format.

Parameters

  bt | BufferedTransformation object

Returns
  element in the group

Implemented in ModExpPrecomputation, DL_GroupPrecomputation_LUC, EcPrecomputation< ECP >, and EcPrecomputation< EC2N >.

## DEREncodeElement()

template<class T >

virtual void DL_GroupPrecomputation< T >::DEREncodeElement | ( | BufferedTransformation & | bt,
|  | const Element & | P
| ) |  | const

pure virtual

Encodes element in DER format.

Parameters

  bt | BufferedTransformation object
  P | Element to encode

Implemented in ModExpPrecomputation, DL_GroupPrecomputation_LUC, EcPrecomputation< ECP >, and EcPrecomputation< EC2N >.

The documentation for this class was generated from the following file:

- eprecomp.h